package com.tzld.longarticle.recommend.server.service.recommend.rank.strategy;


import com.tzld.longarticle.recommend.server.model.dto.Content;
import com.tzld.longarticle.recommend.server.service.recommend.rank.*;
import com.tzld.longarticle.recommend.server.util.CommonCollectionUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author dyp
 */
@Service
@Slf4j
public class FwhColdStartRankStrategy implements RankStrategy {

    public RankResult rank(RankParam param) {

        List<RankItem> items = param.getRankItems();

        List<Content> contents = CommonCollectionUtils.toList(items, RankItem::getContent);

        // 3 选文章
        List<Content> result = new ArrayList<>();
        int size = param.getSize() * param.getUserGroupIds().size();
        result.addAll(contents.subList(0, Math.min(contents.size(), size)));

        return new RankResult(result);
    }

}
