package com.tzld.longarticle.recommend.server.service.recommend.reduce.strategy;

import com.ctrip.framework.apollo.spring.annotation.ApolloJsonValue;
import com.tzld.longarticle.recommend.server.model.dto.Content;
import com.tzld.longarticle.recommend.server.service.recommend.reduce.ReduceParam;
import com.tzld.longarticle.recommend.server.service.recommend.reduce.ReduceStrategy;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.Map;
import java.util.Objects;

@Component
@Slf4j
public class SafeReduceStrategy implements ReduceStrategy {

    @ApolloJsonValue("${reduce.safe.config:[]}")
    private Map<String, Double> safeReduceConfig;

    @Override
    public void reduce(ReduceParam param) {
        for (Content content : param.getContent()) {
            if (Objects.nonNull(content.getKimiSafeScore())) {
                Double safeScore = safeReduceConfig.get(content.getKimiSafeScore());
                if (Objects.nonNull(safeScore)) {
                    content.setScore(content.getScore() - safeScore);
                }
            }
        }
    }
}
